library ssparser_saori;

uses
  SysUtils,
  Classes,
  Windows,
  Ssparser;

{$R *.res}

function GetToken(var p:PChar):String;
begin
  Result := '';
  while (p^ <> #0)and(p^ <> ' ') do
  begin
    if (p^ = #13)and((p+1)^ = #10) then
    begin
      Inc(p);
      break;
    end;
    if p^ in LeadBytes then
    begin
      Result := Result + p^ + (p+1)^;
      Inc(p,2);
    end else
    begin
      Result := Result + p^;
      Inc(p);
    end;
  end;
  Inc(p);
end;

function GetLine(var p:PChar):String;
begin
  Result := '';
  while p^ <> #0 do
  begin
    if (p^ = #13)and((p+1)^ = #10) then
    begin
      Inc(p);
      break;
    end;
    if p^ in LeadBytes then
    begin
      Result := Result + p^ + (p+1)^;
      Inc(p,2);
    end else
    begin
      Result := Result + p^;
      Inc(p);
    end;
  end;
  Inc(p);
end;

function GetElement(var p:PChar;delimiter:string):String;
var
  p_del:PChar;
  len :Integer;
begin
  Result := '';
  p_del := PChar(delimiter);
  len := length(delimiter);
  while p^ <> #0 do
  begin
    if StrLComp(p,p_del,len) = 0 then
    begin
      Inc(p,len);
      break;
    end;
    if p^ in LeadBytes then
    begin
      Result := Result + p^ + (p+1)^;
      Inc(p,2);
    end else
    begin
      Result := Result + p^;
      Inc(p);
    end;
  end;
end;


var
  ss:TSsParser;
  delimiter:string;
  path:string;

{ export function }
function load(h:HGLOBAL;len:integer):bool;cdecl;
begin
  ss := TSsParser.Create(nil);
  ss.LeaveEscape := true;
  ss.EscapeInvalidMeta := true;
  path := PChar(h);
  path := IncludeTrailingPathDelimiter(path);
  delimiter := #1;
  Result := true;
end;

function unload:bool;cdecl;
begin
  ss.Free;
  Result := true;
end;

function request(h:HGLOBAL;var len:integer):HGLOBAL;cdecl;
var
 i:integer;
 req,res,cmd,buf:string;
 arg:array of string;
 arg_cnt:integer;
 p,pp:PChar;
 pattern:TStrings;
begin
  setlength(req,len);
  p := PChar(req);
  MoveMemory(p,Pointer(h),len);
  GlobalFree(h);
  Res := 'SAORI/1.0 500 Internal Server Error'#13#10#13#10;
  arg_cnt := 0;

  cmd:=GetToken(p);
  if cmd = 'GET' then
  begin
    cmd:=GetToken(p);
    if cmd = 'Version' then
    begin
      if GetToken(p) = 'SAORI/1.0' then
      begin
        Res := 'SAORI/1.0 204 No Content'#13#10#13#10;
      end
      else
      begin
        Res := 'SAORI/1.0 400 Bad Request'#13#10#13#10;
      end;
    end
    else
    begin
      Res := 'SAORI/1.0 400 Bad Request'#13#10#13#10;
    end;
  end
  else if cmd = 'EXECUTE' then
  begin
    if GetToken(p) = 'SAORI/1.0' then
    begin
      while p^ <> #0 do
      begin
        pp :=PChar(GetLine(p));
        cmd:=GetToken(pp);
        //MessageBox(0,PChar(cmd),'Argument-1',0);
        if StrLComp('Argument',PChar(cmd),8) = 0 then
        begin
           Delete(cmd,1,8);
           Delete(cmd,Length(cmd),1);
           //MessageBox(0,PChar(cmd),'Argument-2',0);
           i:=StrToIntDef(cmd,-1);
           //MessageBox(0,PChar(IntTostr(i)),'Argument-3',0);
           if arg_cnt <= i then
           begin
             arg_cnt := i+1;
             SetLength(arg,arg_cnt);
           end;
           if (0 <= i) then
           begin
             arg[i]:=GetLine(pp);
             //MessageBox(0,PChar(arg[i]),'Argument-4',0);
           end;
        end;
      end;
      //MessageBox(0,PChar(IntTostr(arg_cnt)),'Argument-last',0);
      //MessageBox(0,PChar(arg[0]),'Command',0);
      if arg_cnt = 0 then
        Res := 'SAORI/1.0 400 Bad Request'#13#10#13#10
      else
      // EscapeInvalidMeta
      if arg[0] = 'SetEscapeInvalidMeta' then
      begin
        if arg_cnt < 2 then
          Res := 'SAORI/1.0 400 Bad Request'#13#10#13#10
        else
        begin
          ss.EscapeInvalidMeta := StrToBoolDef(arg[1],False);
          Res := 'SAORI/1.0 204 No Content'#13#10#13#10;
        end;
      end
      else
      if arg[0] = 'GetEscapeInvalidMeta' then
      begin
        Res := 'SAORI/1.0 200 OK'#13#10 +
            'Result: '+BoolToStr(ss.EscapeInvalidMeta)+#13#10+
            'Charset: Shift_JIS'#13#10 +
            #13#10;
      end
      else
      // LeaveEscape
      if arg[0] = 'SetLeaveEscape' then
      begin
        if arg_cnt < 2 then
          Res := 'SAORI/1.0 400 Bad Request'#13#10#13#10
        else
        begin
          ss.LeaveEscape := StrToBoolDef(arg[1],true);
          Res := 'SAORI/1.0 204 No Content'#13#10#13#10;
        end;
      end
      else
      if arg[0] = 'GetLeaveEscape' then
      begin
        Res := 'SAORI/1.0 200 OK'#13#10 +
            'Result: '+BoolToStr(ss.LeaveEscape)+#13#10+
            'Charset: Shift_JIS'#13#10 +
            #13#10;
      end
      // TagPatternAsDelimitedText
      else if arg[0] = 'SetTagPatternAsDelimitedText' then
      begin
        if arg_cnt < 2 then
          Res := 'SAORI/1.0 400 Bad Request'#13#10#13#10
        else
        begin
          pp := PChar(arg[1]);
          pattern := TStringList.Create;
          while pp^ <> #0 do
          begin
            pattern.Add(GetElement(pp,delimiter));
          end;
          ss.TagPattern := pattern;
          pattern.Free;
          Res := 'SAORI/1.0 204 No Content'#13#10#13#10;
        end
      end
      else if arg[0] = 'GetTagPatternAsDelimitedText' then
      begin
        buf := ss.TagPattern.Text;
        Delete(buf,Length(buf)-1,2);
        Res := 'SAORI/1.0 200 OK'#13#10 +
            'Result: '+StringReplace(buf,#13#10,delimiter,[rfReplaceAll])+#13#10+
            'Charset: Shift_JIS'#13#10 +
            #13#10;
      end
      else if arg[0] = 'AddTagPatternAsDelimitedText' then
      begin
        if arg_cnt < 2 then
          Res := 'SAORI/1.0 400 Bad Request'#13#10#13#10
        else
        begin
          pp := PChar(arg[1]);
          pattern := TStringList.Create;
          pattern.Assign(ss.TagPattern);
          while pp^ <> #0 do
          begin
            pattern.Add(GetElement(pp,delimiter));
          end;
          ss.TagPattern := pattern;
          pattern.Free;
          Res := 'SAORI/1.0 204 No Content'#13#10#13#10;
        end
      end
      // MetaPatternAsDelimitedText
      else if arg[0] = 'SetMetaPatternAsDelimitedText' then
      begin
        if arg_cnt < 2 then
          Res := 'SAORI/1.0 400 Bad Request'#13#10#13#10
        else
        begin
          pp := PChar(arg[1]);
          pattern := TStringList.Create;
          while pp^ <> #0 do
          begin
            pattern.Add(GetElement(pp,delimiter));
          end;
          ss.MetaPattern := pattern;
          pattern.Free;
          Res := 'SAORI/1.0 204 No Content'#13#10#13#10;
        end
      end
      else if arg[0] = 'GetMetaPatternAsDelimitedText' then
      begin
        Res := 'SAORI/1.0 200 OK'#13#10 +
            'Result: '+StringReplace(ss.MetaPattern.Text,#13#10,delimiter,[rfReplaceAll])+#13#10+
            'Charset: Shift_JIS'#13#10 +
            #13#10;
      end
      else if arg[0] = 'AddMetaPatternAsDelimitedText' then
      begin
        if arg_cnt < 2 then
          Res := 'SAORI/1.0 400 Bad Request'#13#10#13#10
        else
        begin
          pp := PChar(arg[1]);
          pattern := TStringList.Create;
          pattern.Assign(ss.MetaPattern);
          while pp^ <> #0 do
          begin
            pattern.Add(GetElement(pp,delimiter));
          end;
          ss.MetaPattern := pattern;
          pattern.Free;
          Res := 'SAORI/1.0 204 No Content'#13#10#13#10;
        end
      end
      // Delimiter
      else if arg[0] = 'SetDelimiter' then
      begin
        if arg_cnt < 2 then
          Res := 'SAORI/1.0 400 Bad Request'#13#10#13#10
        else
        begin
          delimiter := arg[1];
          Res := 'SAORI/1.0 204 No Content'#13#10#13#10;
        end
      end
      else if arg[0] = 'GetDelimiter' then
      begin
        Res := 'SAORI/1.0 200 OK'#13#10 +
            'Result: '+delimiter+#13#10+
            'Charset: Shift_JIS'#13#10 +
            #13#10;
      end
      // TagPattern
      else if arg[0] = 'SetTagPattern' then
      begin
        if arg_cnt < 2 then
          Res := 'SAORI/1.0 400 Bad Request'#13#10#13#10
        else
        begin
          pattern := TStringList.Create;
          for i := 1 to arg_cnt-1 do
          begin
            pattern.Add(arg[i]);
          end;
          ss.TagPattern := pattern;
          pattern.Free;
          Res := 'SAORI/1.0 204 No Content'#13#10#13#10;
        end
      end
      else if arg[0] = 'SetTagPatternFromFile' then
      begin
        if arg_cnt < 2 then
          Res := 'SAORI/1.0 400 Bad Request'#13#10#13#10
        else
        begin
          pattern := TStringList.Create;
          pattern.LoadFromFile(ExpandFileName(path+arg[1]));
          ss.TagPattern := pattern;
          pattern.Free;
          Res := 'SAORI/1.0 204 No Content'#13#10#13#10;
        end
      end
      else if arg[0] = 'GetTagPattern' then
      begin
        Res := 'SAORI/1.0 200 OK'#13#10 +
            'Result: '+IntToStr(ss.TagPattern.Count)+#13#10;

        for i := 0 to ss.TagPattern.Count-1 do
          Res := Res + Format('Value%d: %s'#13#10,[i,ss.TagPattern.Strings[i]]);
        Res := Res + 'Charset: Shift_JIS'#13#10 +
            #13#10;
      end
      else if arg[0] = 'AddTagPattern' then
      begin
        if arg_cnt < 2 then
          Res := 'SAORI/1.0 400 Bad Request'#13#10#13#10
        else
        begin
          pattern := TStringList.Create;
          pattern.Assign(ss.TagPattern);
          for i := 1 to arg_cnt-1 do
          begin
            pattern.Add(arg[i]);
          end;
          ss.TagPattern := pattern;
          pattern.Free;
          Res := 'SAORI/1.0 204 No Content'#13#10#13#10;
        end
      end
      else if arg[0] = 'AddTagPatternFromFile' then
      begin
        if arg_cnt < 2 then
          Res := 'SAORI/1.0 400 Bad Request'#13#10#13#10
        else
        begin
          pattern := TStringList.Create;
          pattern.Assign(ss.TagPattern);
          pattern.LoadFromFile(ExpandFileName(path+arg[1]));
          ss.TagPattern := pattern;
          pattern.Free;
          Res := 'SAORI/1.0 204 No Content'#13#10#13#10;
        end
      end
      // MetaPattern
      else if arg[0] = 'SetMetaPattern' then
      begin
        if arg_cnt < 2 then
          Res := 'SAORI/1.0 400 Bad Request'#13#10#13#10
        else
        begin
          pattern := TStringList.Create;
          for i := 1 to arg_cnt-1 do
          begin
            pattern.Add(arg[i]);
          end;
          ss.MetaPattern := pattern;
          pattern.Free;
          Res := 'SAORI/1.0 204 No Content'#13#10#13#10;
        end
      end
      else if arg[0] = 'SetMetaPatternFromFile' then
      begin
        if arg_cnt < 2 then
          Res := 'SAORI/1.0 400 Bad Request'#13#10#13#10
        else
        begin
          pattern := TStringList.Create;
          pattern.LoadFromFile(ExpandFileName(path+arg[1]));
          ss.MetaPattern := pattern;
          pattern.Free;
          Res := 'SAORI/1.0 204 No Content'#13#10#13#10;
        end
      end
      else if arg[0] = 'GetMetaPattern' then
      begin
        Res := 'SAORI/1.0 200 OK'#13#10 +
            'Result: '+IntToStr(ss.MetaPattern.Count)+#13#10;

        for i := 0 to ss.MetaPattern.Count-1 do
          Res := Res + Format('Value%d: %s'#13#10,[i,ss.MetaPattern.Strings[i]]);
        Res := Res + 'Charset: Shift_JIS'#13#10 +
            #13#10;
      end
      else if arg[0] = 'AddMetaPattern' then
      begin
        if arg_cnt < 2 then
          Res := 'SAORI/1.0 400 Bad Request'#13#10#13#10
        else
        begin
          pattern := TStringList.Create;
          pattern.Assign(ss.MetaPattern);
          for i := 1 to arg_cnt-1 do
          begin
            pattern.Add(arg[i]);
          end;
          ss.MetaPattern := pattern;
          pattern.Free;
          Res := 'SAORI/1.0 204 No Content'#13#10#13#10;
        end
      end
      else if arg[0] = 'AddMetaPatternFromFile' then
      begin
        if arg_cnt < 2 then
          Res := 'SAORI/1.0 400 Bad Request'#13#10#13#10
        else
        begin
          pattern := TStringList.Create;
          pattern.Assign(ss.MetaPattern);
          pattern.LoadFromFile(ExpandFileName(path+arg[1]));
          ss.MetaPattern := pattern;
          pattern.Free;
          Res := 'SAORI/1.0 204 No Content'#13#10#13#10;
        end
      end
      // InputString
      else if arg[0] = 'SetInputString' then
      begin
        if arg_cnt < 2 then
          Res := 'SAORI/1.0 400 Bad Request'#13#10#13#10
        else
        begin
          ss.InputString := arg[1];
          Res := 'SAORI/1.0 204 No Content'#13#10#13#10;
        end
      end
      else if arg[0] = 'GetInputString' then
      begin
        Res := 'SAORI/1.0 200 OK'#13#10 +
            'Result: '+ss.InputString+#13#10+
            'Charset: Shift_JIS'#13#10 +
            #13#10;
      end
      // StrAsDelimitedText
      else if arg[0] = 'GetStrAsDelimitedText' then
      begin
        buf := '';
        for i := 0 to ss.Count-2 do
          buf := buf + ss.Str[i] + delimiter;
        buf := buf + ss.Str[ss.Count-1];
        Res := 'SAORI/1.0 200 OK'#13#10 +
            'Result: '+buf+#13#10+
            'Charset: Shift_JIS'#13#10 +
            #13#10;
      end
      // MarkUpTypeAsDelimitedText
      else if arg[0] = 'GetMarkUpTypeAsDelimitedText' then
      begin
        buf := '';
        for i := 0 to ss.Count-2 do
        begin
          case ss.MarkUpType[i] of
            mtTag:    buf := buf + '^O' + delimiter;
            mtMeta:   buf := buf + '^' + delimiter;
            mtTagErr: buf := buf + 'G[' + delimiter;
            mtStr:    buf := buf + '' + delimiter;
          end;
        end;
        case ss.MarkUpType[ss.Count-1] of
          mtTag:    buf := buf + '^O';
          mtMeta:   buf := buf + '^';
          mtTagErr: buf := buf + 'G[';
          mtStr:    buf := buf + '';
        end;
        Res := 'SAORI/1.0 200 OK'#13#10 +
            'Result: '+buf+#13#10+
            'Charset: Shift_JIS'#13#10 +
            #13#10;
      end
      // Str
      else if arg[0] = 'GetStr' then
      begin
        Res := 'SAORI/1.0 200 OK'#13#10 +
            'Result: '+IntToStr(ss.Count)+#13#10;

        for i := 0 to ss.Count-1 do
          Res := Res + Format('Value%d: %s'#13#10,[i,ss.Str[i]]);

        Res := Res + 'Charset: Shift_JIS'#13#10 +
            #13#10;
      end
      // MarkUpType
      else if arg[0] = 'GetMarkUpType' then
      begin
        Res := 'SAORI/1.0 200 OK'#13#10 +
            'Result: '+IntToStr(ss.Count)+#13#10;

        for i := 0 to ss.Count-1 do
        begin
          case ss.MarkUpType[i] of
            mtTag:    Res := Res + Format('Value%d: %s'#13#10,[i,'^O']);
            mtMeta:   Res := Res + Format('Value%d: %s'#13#10,[i,'^']);
            mtTagErr: Res := Res + Format('Value%d: %s'#13#10,[i,'G[']);
            mtStr:    Res := Res + Format('Value%d: %s'#13#10,[i,'']);
          end;
        end;

        Res := Res + 'Charset: Shift_JIS'#13#10 +
            #13#10;
      end
      //
      else if arg[0] = 'Match' then
      begin
        if arg_cnt < 3 then
          Res := 'SAORI/1.0 400 Bad Request'#13#10#13#10
        else
        begin
          Res := 'SAORI/1.0 200 OK'#13#10 +
            'Result: '+IntToStr(ss.Match(arg[1],arg[2]))+#13#10+
            'Charset: Shift_JIS'#13#10 +
            #13#10;
        end;
      end
      //
      else if arg[0] = 'GetParam' then
      begin
        if arg_cnt < 3 then
          Res := 'SAORI/1.0 400 Bad Request'#13#10#13#10
        else
        begin
          Res := 'SAORI/1.0 200 OK'#13#10 +
            'Result: '+ss.GetParam(arg[1],StrToIntDef(arg[2],0))+#13#10+
            'Charset: Shift_JIS'#13#10 +
            #13#10;
        end;
      end
      //
      else if arg[0] = 'EscapeParam' then
      begin
        if arg_cnt < 2 then
          Res := 'SAORI/1.0 400 Bad Request'#13#10#13#10
        else
        begin
          Res := 'SAORI/1.0 200 OK'#13#10 +
            'Result: '+ss.EscapeParam(arg[1])+#13#10+
            'Charset: Shift_JIS'#13#10 +
            #13#10;
        end;
      end
      else
      begin
        Res := 'SAORI/1.0 400 Bad Request'#13#10#13#10;
      end;
    end
    else
    begin
      Res := 'SAORI/1.0 400 Bad Request'#13#10#13#10;
    end;
  end
  else
  begin
    Res := 'SAORI/1.0 400 Bad Request'#13#10#13#10;
  end;
  //MessageBox(0,PChar(Res),'last',0);
  len := Length(res);
  Result := GlobalAlloc(GMEM_FIXED or GMEM_ZEROINIT,len);
  MoveMemory(Pointer(result),PChar(res),len);
  Exit;
end;

function license:PChar;
begin
Result:='TSsparser''s License'#13#10+
'Copyright (c) 2001-2003 naruto/CANO-Lab (c) 2001-2005 WinBottle Project'#13#10+
'All rights reserved.'#13#10#13#10+
'Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:'#13#10#13#10+
'Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.'#13#10+
'Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.'#13#10+
'Neither the name of the WinBottle Project nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.'#13#10+
'THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, '+
'INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. '+
'IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES '+
'(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)'+
'HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.';
end;

exports
  load,unload,request,license;

begin
end.
 